#pragma once

#include <stdio.h>

#include "accessor.h"

/* A host filesystem file accessor, providing flexpages corresponding to file
   regions. */

class HostFileAccessor : public Accessor
{
protected:
    const char *_path;
    FILE *_fp;

public:
    explicit HostFileAccessor(const char *path, fileid_t fileid);

    virtual void close();

    virtual void open();

    /* Data transfer methods. */

    virtual void fill(Flexpage *flexpage);

    virtual void flush(Flexpage *flexpage);
};

// vim: tabstop=4 expandtab shiftwidth=4
